Doomsday Engine - Feature #438

Accurately hit testing fast projectiles (compatibility option)
2007-03-14 14:18 - vermil

Status: New Start date: 2007-03-14
Priority: Low % Done: 0%
Assignee:

Category: Enhancement

Target version: Vanilla / Gameplay

Description

A bug in the original Doom, projectiles sometimes travel through walls.
Doomsday specific, projectiles sometimes fail to activate XG scripts that can be activated through being hit by projectile.

Both seem more common with fast projectiles than slow ones.

History

#1 - 2013-07-18 17:46 - skyjake

- Milestone: -->v1.8.6

#2 - 2013-10-22 18:23 - skyjake

- Tags set to Doom, PlaySim

- Category set to Defect

- Priority changed from Low to Normal

- Target version deleted (1.8.6)

Perhaps occurs when a missile travels so fast that the hit testing range skips over some line?

#3 - 2013-10-22 23:43 - danij

Yep, that is precisely the cause. lts a flaw in the vanilla algorithm for detecting crossed lines, which, we can't change without seriously affecting mod
compatibility.

#4 - 2013-10-23 08:12 - skyjake

- Tracker changed from Bug to Feature

- Subject changed from Projectiles sometimes travel through walls to Accurately hit testing fast projectiles

- Category changed from Defect to Vanilla emulation

- Priority changed from Normal to Low

Then we can at most add a compatibility option for enabling or disabling more accurate hit testing for fast-moving objects. Converting to a Feature.

#5 - 2013-10-23 10:48 - vermil

What spurred me on these issues was that | made a couple of mods/reimages of other games in the past, that | didn't quite complete or release. I've
still got the files and have tweaked them from time to time.

One, a Doom mod, featured XG doors that could be blown up with rockets; the rockets were always exploding on the door, but it wasn't activating the
XG line unless | struck the doors from certain angles.

In the other Heretic mod, | had a bunch of small projectiles with a speed of 15, but they regularly kept going through walls; though they always

exploded on the backs of 1 sided linedefs they hit after. The strange thing is that 15 is not a high speed; various missiles in Doom are that fast, so
maybe it was the size or something of my projectiles. They had a radius and height of 4.

#6 - 2013-10-23 10:50 - vermil

| will add that yes | am aware, that rocket splash damage doesn't trigger XG. | refer to the actual rocket above.

#7 - 2019-11-29 15:24 - skyjake

- Subject changed from Accurately hit testing fast projectiles to Accurately hit testing fast projectiles (compatibility option)
- Category changed from Vanilla emulation to Enhancement

- Target version set to Vanilla/ Gameplay
